import numpy as np
import sys
import matplotlib.pyplot as plt
import scipy.special as sp

# Test Input
N=64; N2=32; X=np.zeros(N);
for i in range (5,N-5,1):
	X[i]=i;

# Filters
NF=8; NF2=4; HL=np.zeros(NF);HH=np.zeros(NF);

# Output
YL=np.zeros(N); YH=np.zeros(N);

# Decimated (by 2) Output
YL2=np.zeros(N2); YH2=np.zeros(N2);

##############################
# FIR FILTER coef
# Low -pass:
HL[4]= 0.48998080
HL[5]= 0.69428270/10.0
HL[6]=-0.70651830/10.0
HL[7]= 0.93871500/100.0
for i in range (0,NF2,1):
	HL[i] = HL[NF-1-i]
# High-pass:
arg = 1.
for i in range (0,NF,1):
	HH[i] = HL[i]*arg
	arg = -arg

#	print(i,HL[i],HH[i])
###############




###############################
# Convolution at every other sample point
for i in range (0,N,1):   
	YL[i]=0
	YH[i]=0
	if(i%2==0):
		for k in range (-NF2+1,NF2+1,1):
			iarg= i-k
			if(iarg>=0 and iarg < N ):
				YL[i]=YL[i] +HL[k+NF2-1]*X[iarg]
				YH[i]=YH[i] +HH[k+NF2-1]*X[iarg]
###############################
# save decimated data 
for i in range (0,N2,1):
	YL2[i]=YL[2*i]
	YH2[i]=YH[2*i]

#	print(i,YL2[i],YH2[i])
#################################
# reconstruction check
XL=np.zeros(N)
XH=np.zeros(N)
Xreconstructed=np.zeros(N)
for i in range (0,N,1):
	XL[i]=0
	XH[i]=0
	for k in range (-NF2+1,NF2+1,1):
		iarg= i-k
		if(iarg>=0 and iarg < N ):
			XL[i]=XL[i] +HL[k+NF2-1]*YL[iarg]
			XH[i]=XH[i] +HH[k+NF2-1]*YH[iarg]
	Xreconstructed[i]= 2.0*(XL[i]-XH[i])
		

for i in range (0,N,1):
	print( i,X[i],Xreconstructed[i])

plt.plot( Xreconstructed,color='red')
plt.plot( X,color='green')
plt.show()


	




